﻿init python:
    class grid_piece:
        def __init__(self, img, rotation, blocked):
            self.img = img
            self.rotation = rotation
            self.blocked = blocked
    class grid_walker:
        def __init__(self, name, x, y):
            self.name = name
            self.x = x
            self.y = y
    class grid_puzzle_class:
        def __init__(self, solution, walker):
            self.solution = solution
            self.grid = solution
            self.walker = grid_walker("Player",walker[0],walker[1])
            self.locked = False
            self.blocked = self.grid[self.walker.y][self.walker.x]

        def reset(self):
            pass

        def move(self, direction):
            self.blocked = self.grid[self.walker.y][self.walker.x]
            if direction in self.blocked.blocked:
                pass
            else:
                if direction == "up":
                    self.walker.y -= 1
                elif direction == "left":
                    self.walker.x -= 1
                elif direction == "down":
                    self.walker.y += 1
                elif direction == "right":
                    self.walker.x += 1
                self.locked = True
        def unlock(self):
            self.locked = False
default g00 = grid_piece(
    0,0, []
)

default g10 = grid_piece(
    1,0, []
)
default g20 = grid_piece(
    2,0, ["up","left"]
)
default g21 = grid_piece(
    2,1, ["up","right"]
)
default g22 = grid_piece(
    2,2, ["down","right"]
)
default g23 = grid_piece(
    2,3, ["down","left"]
)

default g30 = grid_piece(
    3,0, ["up"]
)
default g31 = grid_piece(
    3,1, ["right"]
)
default g32 = grid_piece(
    3,2, ["down"]
)
default g33 = grid_piece(
    3,3, ["left"]
)

default g40 = grid_piece(
    4,0, ["left","right"]
)
default g41 = grid_piece(
    4,1, ["up","down"]
)

default g50 = grid_piece(
    5,0, ["left","up","right"]
)
default g51 = grid_piece(
    5,1, ["up","right","down"]
)
default g52 = grid_piece(
    5,2, ["right","down","left"]
)
default g53 = grid_piece(
    4,3, ["down","left","up"]
)


default grid_1 = grid_puzzle_class(
    [
        [g20,g30,g21,g00],
        [g33,g10,g10,g21],
        [g33,g31,g52,g40],
        [g23,g32,g41,g22],
    ],
    [2,2]
)







screen grid_puzzle(g):
    # text str(g.blocked.blocked)
    modal True
    if g.locked:
        timer .2 repeat True action Function(g.unlock)
        key "w" action NullAction()
        key "a" action NullAction()
        key "s" action NullAction()
        key "d" action NullAction()
    else:
        key "w" action Function(g.move, "up")
        key "a" action Function(g.move, "left")
        key "s" action Function(g.move, "down")
        key "d" action Function(g.move, "right")

    fixed:
        fit_first True
        align .5,.5
        vbox:
            spacing 0 
            for j in g.grid:
                hbox:
                    spacing 0
                    for i in j:
                        button:
                            at rotate(i.rotation*90)
                            xysize 100,100 background "grid/{}.png".format(i.img)
                            # text str(i.rotation) align .5,.5
        if g.walker:
            frame:
                at grid_ball(g.walker.x*100, g.walker.y*100)
                xysize 20,20
                anchor .5,.5 pos 50,50

    # frame:
    #     align .5,.5
    #     for m,j in enumerate(g.grid):
    #         for n,i in enumerate(j):
    #             button:
    #                 offset n*140,m*140
    #                 xysize 40,40 background "#fff9"
    #                 text str(i) 

transform grid_ball(x, y):
    ease .2 xoffset x yoffset y

transform rotate(r):
    rotate_pad False
    subpixel True
    rotate r
label grid_puzzle_example:
    
    call screen grid_puzzle(grid_1)
    return




